## Contributing to `LFPykit`!

Thank you for taking the time to contribute!

* [Suggesting a feature](#suggesting-a-feature)
* [Filing a bug report](#filing-a-bug-report)
* [Submitting a pull request](#submitting-a-pull-request)

## Suggesting a feature

If you have an idea for a feature, please let us know!

Check list:

* Consider if it is necessary in this library
* Check if the feature has not been suggested in open or closed issues

## Filing a bug report

If you are having trouble with LFPykit, please raise an Issue to let us know.

Make sure you tell us how to reproduce the problem as detailed as possible (include OS, Python version, Python virtual environment details, reproducing code etc.)

## Submitting a pull request

If you've decided to fix a bug, then great! Contributions to the project is very much welcome.
If you are working on a feature or reported bug, let it be known by replying in the issue.
Contributing examples in the form of Jupyter notebooks are also encouraged.

When contributing please keep your code style consistent.
We try to stick to the pep8 guidelines for Python (https://www.python.org/dev/peps/pep-0008/).

#### Do

* Do use pep8 style guidelines
* Do comment your code
* Do submit only a single example/feature per pull-request
* Do include a description of what your example is expected to do
* Do add details of your example to examples/README.md if it exists

#### Don't

* Don't include any license information in your examples- our repositories are GPL licensed

### If you're submitting an example

Try to do one thing, and do it concisely. Keep it simple. Don't mix too many ideas.

The ideal example should:

* demonstrate one idea, technique or API as concisely as possible in a single Jupyter Python notebook
* *just work* when you run it. Although sometimes configuration is necessary
* be well commented and attempt to teach the user how and why it works
* document any required configuration, and how to install API keys, dependencies, etc.

### Licensing

When you submit code to our libraries, you implicitly and irrevocably agree to adopt the associated licenses. You should be able to find this in the file named `LICENSE`.

### Subitting your code

Once you're ready to share your contribution with us you should submit it as a Pull Request.

* Be ready to receive and embrace constructive feedback.
* Be prepared for rejection; we can't always accept contributions. If you're unsure, ask first!
